#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <cstring>
using namespace std;

int n; //numero de negociantes inicial
int v[1000][1000]; //matriz de preferencia
int cnt[1000]; //proxima casa que mais gosta em v[i][cnt[i]], para um negociante i
int s[1000]; //negociantes 1=ativo, 0=ja tem casa
int t; //numero de negociantes ativos em 's'
int viz[1000]; //vizinho do negociante i é v[i]
int ja[1000]; //ja visitei, marca pra achar ciclos
int ciclo[1000]; //inicio de cada ciclo em ciclo[i]
int q; //numero de ciclos
int casa[1000]; //casa[i] = casa do negociante i

int pd[1000];
int cc[1000];
int ncc;

vector<int> put[1000];


void fazAtribuicaoEatualiza() {

	//atribuiçao de casas
	for(int i=0; i <q;i++) {
		int ini = ciclo[i];
		//printf("ciclo começa em %d\n" , ini);
		int ant,x;
		for(x = viz[ini], ant = ini; x!= ini; ant =x, x = viz[x]) {
			casa[ant] = x;
			s[ant] = 0;
			t--;
		}
		//printf("ciclo termna no %d\n", ant);
		s[ant] = 0;
		t--;
		casa[ant] = ini;
	}

	//anda na ordem de preferencia
	for(int i=0;i<n;i++) {
		while(cnt[i] <n && s[v[i][cnt[i]]] == 0) {
			cnt[i]++;
		} 
	}

}

void dfs(int v) {
	if(pd[v]) return;
	pd[v] = 1;
	for(int i=0;i< (int) put[v].size();i++)
		dfs(put[v][i]);
}

void roda() {
	for(int i=0;i<n;i++) {
		if(!pd[i] && s[i]) {
			cc[ncc++] = i;
			dfs(i);
		}
	}
}

void resolve() {
	if(t==0) return;

	for(int i=0;i<n;i++) put[i].clear();

	for(int i=0;i<n;i++) {
		if(s[i]) { 
			viz[i] = v[i][cnt[i]];
			put[i].push_back(viz[i]);
			put[viz[i]].push_back(i);
		}
		else viz[i] = -1;
		ja[i] = 0;
		pd[i] = 0;
	}

	//acha componentes
	q = 0;
	ncc=0;
	roda();

	//para cada componente, procura os ciclos
	for(int i=0;i<ncc;i++) {
		for(int k=cc[i];;k=viz[k]) {
			ja[k]++;
			if(ja[viz[k]]) { 
				ciclo[q++] = viz[k];
				break;
			}
		}		
	}

	fazAtribuicaoEatualiza();
	resolve();
}

void imprime() {
	for(int i=0;i<n;i++) {
		printf("Negociante %d termina com a casa %d\n", i+1, casa[i]+1);
	}
	printf("\n");
}

int main() {

	scanf("%d", &n);

	for(int i=0;i<n;i++) {
		cnt[i] = 0;
		s[i] = 1;
		for(int j=0; j<n;j++) {
			scanf("%d" , &v[i][j]);
			v[i][j]--;
		}
	}
	t = n;
	
	resolve();
	imprime();

    return 0;
}

